// vfb, 970410, add "scalev" for back-compatibility (wrong volume on spheres...)
// vfb, redesign, 951221

#import <objectbase.h>
#import <objectbase/SwarmObject.h>

#define TRUE 1
#define FALSE 0
// from Matlab eps
#define EPSILON 2.2204e-16
#define MaxPerQuad  7	
// compiler switches
#define VERBOSE
#define MUTUAL
#undef SQUARE
#undef EXTRALOCO

typedef enum { NoEps, Capsule, Slime, SelfBinding, AllBinding, SlimersBinding} EpsType;

typedef enum { LabelParam, IntParam, DoubleParam, StringParam} ParamType;
typedef double GFloat;
typedef GFloat GCoord; 
typedef GFloat GRate; 
typedef GFloat GArea;
typedef GFloat ResQuant;
typedef enum { SizeSmall, SizeMedium, SizeLarge } SizeType;
#define SIZETYPES 3
typedef enum { StageInfant, StageYouth, StageAdult } StageType;
#define STAGETYPES 3
#define CIRCLE_THICKNESS 2

// Some utilities for converting between radius, area, and volume
extern GArea radius2area(GCoord r);
extern ResQuant radius2volume(GCoord r, GCoord scaler, GCoord scalev);
extern GCoord volume2radius(ResQuant v, GCoord scaler, GCoord scalev);
// These two functions were added to provide simple, unscaled versions of the above two
extern ResQuant radius2sphere(GCoord r);
extern GCoord sphere2radius(ResQuant v);

// 2D
extern GCoord distance(GCoord x1, GCoord y1, GCoord x2, GCoord y2);
extern BOOL ptToward(GCoord fromx, GCoord fromy, GCoord tox, GCoord toy,
              GCoord dist, GCoord *ptx, GCoord *pty);
extern GFloat angleToward(GCoord fromx, GCoord fromy, GCoord tox, GCoord toy);
// 3D
GCoord distance3D(GCoord x1, GCoord y1, GCoord z1, GCoord x2, GCoord y2, GCoord z2);
BOOL ptToward3D(GCoord fromx, GCoord fromy, GCoord fromz, GCoord tox, GCoord toy, GCoord toz,
		GCoord dist, GCoord *ptx, GCoord *pty, GCoord *ptz);

// Used in constructing agents' equivalent area squares or equivalent volume cubes in Mcr and Diffuse
extern GCoord SqrtPiOver2;
extern GCoord CubertPiOver6;
// Used in Diffuse for converting substrate concentrations from ionized to unionized
extern GRate pH;
extern GRate celsius;

extern char GeckoVersion[];
extern char* timeString();
extern char* colorName(int color);

#define geckoError( eventType, formatString, args... ) \
[eventType raiseEvent: \
"\r" __FUNCTION__, __FILE__, __LINE__, formatString , ## args]
#define geckoWarning(formatString, args) \
printLog("WARNING: "); printLog(formatString, args);

#define samesign(a,b) ( ( (a < 0) && (b < 0) ) || ( (a >= 0) && (b >= 0) ) )

/* Lifted from TkInt.h...980327
 *
 * The macro below is used to modify a "char" value (e.g. by casting
 * it to an unsigned character) so that it can be used safely with
 * macros such as isspace.
 */

#define UCHAR(c) ((unsigned char) (c))
