// vfb, rewrite, 960116.
// vfb, orig, 951110:

#import <objectbase.h>
#import "Base.h"
#import "Animal.h"

@interface Carnie: Animal {
  @public
    GRate smell_radius;		// multiplier on radius for smelling distance
    int sleeptime;		// how long it takes to assimilate a grazer
    int sleepleft;		// rounds left before wake up.
    timeval_t last_ate;	  	// [geckoControl getCurrentTime] at last meal
    GRate hibernatetax;		// taxrate while hibernating
    timeval_t hibernaterule;	// hibernate if haven't eaten in this long
}

// routines I need to override from Animal

+create;
-recycle;			// add to recycling list -of this type-
-reuse;			        // scrounge recycling list -of this type-
-recycleClear;                  // clear out recycling list
-copymom;			// self=mom, returns baby

-liveGrandma: (Species*) s;	// initialize/reinit a default carnie
-addSpeciesParams;

-resetSmellRadius: (GRate) sr Sleep: (int) s HibRule: (int) hr 
      HibTax: (GRate) ht;
-setSmellRadius: (GRate) sr;
-setSleep: (int) s;
-setHibRule: (int) hr;
-setHibTax: (GRate) ht;
-setConvertRate: (GRate) nr;

-(BOOL) hibernating;		// yes?
-(BOOL) reproduce;		
-move;
-hunt;				// reproduce -or- hunt, not both
-paytaxRate: (GRate) rate;	// pays at two different rates
-(GCoord) getMoveRadius;
-(GCoord) getPerceiveRadius; 
-step;				// has sleeping behaviors, so override
-printv;

// need to override in CarnieZoo
-(Animal*) findCritterR: (GCoord) distance 
            Attack: (BOOL) attack Root: (Quad*) huntroot;
@end


extern BOOL spidersReproducedFlag; // used in a fitness function
