// vfb, redesign, 951221:
// vfb, redesign, 960909:  
// 990509:
// Critter is now more or less a container for all living creatures in our Gecko world.
// Critters don't exist as such, only animals, grazers, plants, bacilli, etc. do.
// Eps is also a critter, though it's a blob of dead matter excreted by Bacilli

#import <objectbase.h>
#import <objectbase/SwarmObject.h>	
#import <activity.h>				  
#import "Base.h"
#import "Mcr.h"
#import "Quad.h"
#import "Colors.h"
#import "Species.h"

// All living agents in Gecko and Eps are Critters

@interface Critter: SwarmObject {
  // defining settings
 @public
  Species* species;	  // Species more than just a label
  GCoord breedsize;	  // breeding radius (reproductive maturity)
  GCoord kidsize;	  // kids' initial radius
  GCoord minsize;	  // die at minsize

  // working settings  
  int color;		  // color map index
  GCoord x, y, z;	  // center
  GCoord radius;	  // current size
  ResQuant wannax, wannay, wannaz;   // which way I wanna go...interpretation varies
  
  // life history stats
  timeval_t birthday;	  // getCurrentTime at birth
  int kidcount;		  // kids I've had

  // structural
  Quad* myquad;		  // backpointer to my quadtree record		
  id    hook;		  // for linking them together arbitrarily (recycling)
}

// subroutines of create--public for use by subclasses
-init;				
-recycle;			// add to recycling list -of this type-
-reuse;			        // scrounge recycling list -of this type-
-recycleClear;                  // clear out recycling list
+create;
-copymom;			// self=mom, returns baby
-liveGrandma: (Species*) s;	// initialize/reinit a default plant.

-setX: (GCoord) cx Y: (GCoord) cy Radius: (GCoord) r;	 
-setX: (GCoord) cx Y: (GCoord) cy Z: (GCoord) cz Radius: (GCoord) r;
-getX: (GCoord*) cx Y: (GCoord*) cy Radius: (GCoord*) r; 
-getX: (GCoord*) cx Y: (GCoord*) cy Z: (GCoord*) cz Radius: (GCoord*) r;
-getX: (GCoord*) cx Y: (GCoord*) cy;	  		
-getX: (GCoord*) cx Y: (GCoord*) cy Z: (GCoord*) cz;
-(GCoord) getX;
-(GCoord) getY;
-(GCoord) getZ;
-(GCoord) getGX; // same as getX, getZ, and getY, but unique'd names
-(GCoord) getGY;
-(GCoord) getGZ;

-(const char*) getInstanceName; 
-(char*) getName; 
-(Species*) getSpecies;

-setAgentsFromFile: (char*) filename; // dummy
-(int) getProcess; // dummy
-(EpsType) getEps; // dummy
-(GRate) doTheLocomotion; // dummy

// Swarm ought to be shot for this...took get/setColor and made
// global in gui.h so not available to applications....argh...
-setGColor: (int) colorid;	
-(int) getGColor;	

-setQuad: (Quad*) q;		// set quad backpointer
-(Quad*) getQuad;

-(GCoord) getRadius;		// others perceive -me- as radius
-(GCoord) getKidRadius;		// radius of the kid
-(GCoord) getMinRadius;		// minimum living size
-(GCoord) getBreedRadius;	// size I reproduce at
-(GCoord) getPerceiveRadius;	// usually = radius

-getDirectionX: (GCoord*) dx Y: (GCoord*) dy;	// unit vector
-getDirectionX: (GCoord*) dx Y: (GCoord*) dy Z: (GCoord*) dz;
-(double) getDirectionAngle; // sets wannax,y and returns angle
-setDirectionX: (GCoord) dx Y: (GCoord) dy;
-setDirectionX: (GCoord) dx Y: (GCoord) dy Z: (GCoord) dz;
-addDirectionX: (GCoord) dx Y: (GCoord) dy Weight: (double) weight;
-addDirectionX: (GCoord) dx Y: (GCoord) dy Z: (GCoord) dz Weight: (double) weight;

-(GArea) getArea;		
-(ResQuant) getVolume;		
-(Quad*) getRoot;

-(BOOL) hiddenExposed: (Mcr*) exposed;	// dummy usually

-(void) getMcr: (Mcr*) m;  // calculate, don't return myquad
-(void) getMcb: (Mcr*) m;

// stat support--eminently overrideable
// statsFinalize is your chance to add any specific stats to the Species, or
// attempt to override the labels on graphs, or whatever.
-statsFinalize;			// called at end of Species building on grandma

-(int) getAgeBucket;
-(int) getDefaultAgeCount;	// 5, if have no brighter ideas...
-(int) getStageBucket;
-(int) getDefaultStages;	// 3, if have no brighter ideas...
-(int) getSizeBucket;
-(int) getDefaultSizes;		// 3, if have no brighter ideas...

// "specific" stats are defined and run by a species family (subclass of 
// critter), rather than the generics provided in the "Species" machinery.
-calcSpecific: (id) specStats;	// calls BucketDistrib calc by default.
// You can also return false if you want Species-observeSpecific to create
// traces for you for each derived in each bucket.
-(BOOL) observeSpecific: (id) specStats; // false--take default.
-(int) getSpecificBucket;	// 0, if have no brighter ideas...
-(int) getSpecificCounter: (int) anEvent; // -1, if not implemented
// getSpecificSum says which summer to add to, getSpecificAmount says
// how much to add to the summer
-(int) getSpecificSum: (int) anEvent; // -1, if not implemented
-(double) getSpecificAmount: (int) anEvent; // 0, if not implemented
-(int) getSpecificNumBuckets;	// 1, if have no brighter ideas...
-(int) getSpecificCounts;	// 1, if have no brighter ideas...
-(int) getSpecificSums;		// 1, if have no brighter ideas...
-(int) getSpecificDeriveds;	// 1, if have no brighter ideas...

-print;
-println;
-printv;

@end
