// vfb, add maxAge to tlc's, 970204
// vfb, orig, 961015:  Animal variants

#import "Animal.h"

@interface Puffball: Animal {
  GCoord kidcost;	  // multiplier on kid's biomass
}

-init;				
-recycle;			// add to recycling list -of this type-
-reuse;			        // scrounge recycling list -of this type-
-recycleClear;                  // clear out recycling list
+create;
-copymom;			// self=mom, returns baby
-liveGrandma: (Species*) s;	// initialize/reinit a default puffball
-addSpeciesParams;

-(GCoord) getChildRadius;	// distance at which to place kid

-setKidCost: (GCoord) kc;
-(GCoord) getKidCost;
-(BOOL) reproduce;		// false if didn't -choose- to.
-printv;
@end

@interface TimeLimitCritter: Animal {
  int adultTime;	  // when we become adult (sets br at that time)
  int maxAge;		  // if nonzero, dies at birthday+maxage, else ignored
}
-init;				
-recycle;			// add to recycling list -of this type-
-reuse;			        // scrounge recycling list -of this type-
-recycleClear;                  // clear out recycling list
+create;
-copymom;			// self=mom, returns baby
-liveGrandma: (Species*) s;	// initialize/reinit a default timeLimitAnimal
-addSpeciesParams;

-setAdultTime: (int) at;
-(int) getAdultTime;
-setMaxAge: (int) ma;
-(int) getMaxAge;

-(BOOL) reproduce;		// false if didn't -choose- to.
-step;
-printv;
@end

@interface NoReverseTLC: TimeLimitCritter {
  double structural;	// percent of body we can't lose
  GCoord curmin;	// minimum size du jour
}
-recycle;			// add to recycling list -of this type-
-reuse;			        // scrounge recycling list -of this type-
-recycleClear;                  // clear out recycling list
+create;
-copymom;			// self=mom, returns baby
-liveGrandma: (Species*) s;	// initialize/reinit a default NoReverseTLC
-addSpeciesParams;

-setStructural: (double) st;
-(double) getStructural;
-paytax;
-printv;
@end

