// The definition of a Land(scape) object. vfb rewrite, 951221.

#import <objectbase.h>				
#import "Base.h"
#import "Mcr.h"
#import "Quad.h"
#import "Res.h"
#import "Colors.h"
#import "Animal.h"
#import "Stat.h"
#import "Site.h"
#import "ResourceQuad.h"

// Warning:  at some point, FeedQuad should be upgraded to have a Metabolism,
// so that it can recycle resources, instead of modeling with individual
// agents, which is computationally cumbersome.  For instance, taxes (including
// dead critters) could be recycled at some efficiency back into plantfood.

@interface FeedQuad: ResourceQuad {
    GRate	prodfunc;	// production per unit area per step.
    GRate	feedfunc;	// current feed per unit area.
    GRate       reserveLimit;
}
+create;

-landGrandma: (Site*) s;// fills in one default site
-copymom;		// self=mom, returns copy

-(int) getGColor;
-setGColor: (int) c;

-produce: (ResType) res Rate: (GRate) rate Limit: (GRate) lim;
-addResourceAmount: (ResQuant) amount X: (GCoord) x Y: (GCoord) y;

// "Amount" is interpreted as "percent" here.
-(ResQuant) feedCritter: (Animal*) eater Amount: (ResQuant) amount Area: (Mcr*) m;
       
-stepResources;

-(ResQuant) curFeed;		  // units of this resource, obviously 	

// the following exist for the convenience of the Params scheme--not for
// calling directly.
-setProdFunc: (GRate) rate;
-setLimit: (GRate) lim;

-print;

@end
