// Copyright (C) 1996 - 1999 Yale Institute for Biospheric Studies and Ginger Booth.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

// vfb, original, 960620:  copy from HeatbugObserverSwarm and fit to Gecko.

// The Gecko Display swarm encapsulates the graphical user interface objects.

#import <objectbase.h>
#import <simtoolsgui.h>
#import <simtoolsgui/GUISwarm.h>
#import <space.h>
#import <activity.h>
#import <gui.h>
#import <collections.h>
#import <simtools.h>
#import "GeckoModelSwarm.h"
#import "QuadDisplay.h"

@interface GeckoDisplaySwarm : GUISwarm {
    int displaycycle;			// display goes displaycycleth round

    id displayActions;			// schedule data structures
    id displaySchedule;

    GeckoModelSwarm * geckoModelSwarm;	// the Swarm we're displaying

    // Display objects.
    QuadDisplay * worldDisplay; 	// circles drawn here
}

// Methods overriden to make the Swarm.
+createBegin: (id) aZone;
-setModel: (GeckoModelSwarm *) gms;	// mandatory
-getControlPanel;
-getActionCache;
-createEnd;

-setDisplaycycle: (int) dc;

-buildObjects;
-buildActions;
-activateIn: (id) swarmContext;
-resetClear;

@end
