// vfb, orig, 961107
// vfb, fix tlg's, 961217. (min breedsize = kid+min)

#import "RandSource.h"
#import "Animal.h"
#import "CritterZoo.h"
#import "Grazer.h"
#import "GrazerZoo.h"
#import "LandRoot.h"
#import "GeckoControlSwarm.h"
#import "Stat.h"
#import <stdlib.h>
#import <math.h>
#import <simtools.h>
// #import <values.h>

@implementation TLG_Kris

TLG_Kris* recycleTLG_Kriss = 0;
Mcr* huntwin;
Mcr* feedwin;

-recycle
{
    [species tallyDeath: self];
    
    hook = recycleTLG_Kriss;
    recycleTLG_Kriss = self;
    [species decrementCensus];
    return nil;
}

-recycleClear
{
    TLG_Kris* togo;
    while (recycleTLG_Kriss) {
        togo = recycleTLG_Kriss;
        recycleTLG_Kriss = recycleTLG_Kriss->hook;
        [togo->energy drop];
        [togo drop];
    }
    return self;
}


-reuse
{
    TLG_Kris* result = recycleTLG_Kriss;
    recycleTLG_Kriss = recycleTLG_Kriss->hook;
    result->hook   = nil;
    return result;
}

+create 
{
    id result;
    
    if (recycleTLG_Kriss) {
        result = [recycleTLG_Kriss reuse];
    } else {
        result = [TLG_Kris createBegin: globalZone];
        [result allocEnergy];
    }
    [result init];
    
    return result;					
}

-copymom
    // create an agent matching mom in all heritable respects
{
    TLG_Kris* baby;
    Quad* newQuad;

    baby = [TLG_Kris create];
    baby->species   = species;
    [energy copyTo: baby->energy];
    baby->color     = color;
    [species incrementCensus];
    [species tallyBirth: self];
    baby->breedsize = 10000;
    baby->kidsize   = kidsize;
    baby->minsize   = minsize;
    baby->scaleradius = scaleradius;
    baby->scalev = scalev;
    baby->growrate  = growrate;
    baby->lastmealx = lastmealx;
    baby->lastmealy = lastmealy;
    baby->veer      = veer;
    baby->moverule  = moverule;
    baby->adultTime = adultTime;

    newQuad = [Quad create];
    [newQuad setData: baby Type: critter];
    [newQuad setSibling: nil];
    [newQuad setChild: nil];
    [newQuad setParent: nil];
    [baby setQuad: newQuad];

    return baby;
}
-setAdultTime: (int) at { adultTime = at; return self;}
-(int) getAdultTime { return adultTime;}

-addSpeciesParams
{
    [super addSpeciesParams];

    [species addParam: "AdultTime" Vary: 0 IValue: adultTime
          Message: M(setAdultTime:) Owner: self];

    return self;   
}

-liveGrandma: (Species*) s
{
    [huntwin drop];
    huntwin = [Mcr create];
    [feedwin drop];
    feedwin = [Mcr create];
    
    [energy addConvertFrom: carbos To: proteins Rate: (1.0/3.0)];
    [energy addTax: proteins Rate: .365 Exponent: .75]; // .08
    breedsize   = 10000;
    kidsize     = 3.2;
    minsize     = 3.0;
    scaleradius = 1.0;
    scalev = 1.0/M_PI;
    growrate    = .0306;
    veer        = 3.77; // M_PI;
    adultTime   = 133;
    
    species = s;
    [self setGColor: [species getGColor]];
    [self addSpeciesParams];
    
    return self;
}

-(BOOL) reproduce
    // False if didn't.  For now, select random angle for kid.
{
    TLG_Kris* baby;
    GCoord distance;
    ResList* kidgets;
    double angle;
    Quad* myRoot;
    
    if ([geckoControl getCurrentTime] == (adultTime + birthday)) {
        breedsize = radius;
    } else if ([geckoControl getCurrentTime] < (adultTime + birthday)) {
        return 0;
    }
    
    if (breedsize < kidsize) {
        minsize = 10000; /* die soon... */
        return 0;
    }

    if (radius < breedsize)
        return 0;

    angle = 2.0 * M_PI * [randSource evenRand];

    // record a birth
    if (kidcount == 0)
        firstbornon = [geckoControl getCurrentTime];
    kidcount++;

    // make the kid
    baby         = [self copymom];
    distance     = [self getChildRadius];
    baby->x      = x + ( distance * cos(angle) );
    baby->y      = y + ( distance * sin(angle) );
    baby->wannax = cos(angle);
    baby->wannay = sin(angle);
    baby->radius = kidsize;

    // transfer resources 
    kidgets = [self kidshare];
    [energy debit: kidgets];
    [self resetRadius];
    baby->energy = [baby->energy setStores:  kidgets];

    // hang on quad tree
    [baby getMcr: baby->myquad->mcr];
    myRoot = myquad->parent;
    while ((myRoot->type != sessile) && (myRoot->type != mobile))
        myRoot = myRoot->parent;
    [myRoot addNode: baby->myquad];

    [kidgets drop];
    return 1;
}

-printv
{
    [super printv];
    printLogD("growrate = %7f, ", growrate);
    printLogD("veer = %7lf, ", veer);
    printLog("adultTime = %3d, ", adultTime);
    printLog("moverule = %d\n\n", moverule);
    return self;
}
@end

@implementation CCG_Kris

CCG_Kris* recycleCCG_Kriss = 0;
Mcr* huntwin;
Mcr* feedwin;

-recycle
{
    [species tallyDeath: self];
    
    hook = recycleCCG_Kriss;
    recycleCCG_Kriss = self;
    [species decrementCensus];
    return nil;
}

-recycleClear
{
    CCG_Kris* togo;
    while (recycleCCG_Kriss) {
        togo = recycleCCG_Kriss;
        recycleCCG_Kriss = recycleCCG_Kriss->hook;
        [togo->energy drop];
        [togo drop];
    }
    return self;
}


-reuse
{
    CCG_Kris* result = recycleCCG_Kriss;
    recycleCCG_Kriss = recycleCCG_Kriss->hook;
    result->hook   = nil;
    return result;
}

-init
{
    int i;
    [super init];
    colorsToEat = (int*) [globalZone alloc: MAXCHOOSYCOLORS * sizeof(int)];
    for (i=0; i< MAXCHOOSYCOLORS; i++)
        colorsToEat[i] = -1;
    numColors = 0;
    return self;
}

+create 
{
    id result;
    
    if (recycleCCG_Kriss) {
        result = [recycleCCG_Kriss reuse];
    } else {
        result = [CCG_Kris createBegin: globalZone];
        [result allocEnergy];
    }
    [result init];
    
    return result;					
}

-copymom
    // create an agent matching mom in all heritable respects
{
    CCG_Kris* baby;
    Quad* newQuad;
    int i;

    baby = [CCG_Kris create];
    baby->species   = species;
    [energy copyTo: baby->energy];
    baby->color     = color;
    [species incrementCensus];
    [species tallyBirth: self];
    baby->breedsize = 10000;
    baby->kidsize   = kidsize;
    baby->minsize   = minsize;
    baby->scaleradius = scaleradius;
    baby->scalev = scalev;
    baby->growrate  = growrate;
    baby->lastmealx = lastmealx;
    baby->lastmealy = lastmealy;
    baby->veer      = veer;
    baby->moverule  = moverule;
    baby->adultTime = adultTime;
    baby->smell_radius = smell_radius;
    baby->numColors = numColors;
    for (i=0; i<numColors; i++)
        baby->colorsToEat[i] = colorsToEat[i];

    newQuad = [Quad create];
    [newQuad setData: baby Type: critter];
    [newQuad setSibling: nil];
    [newQuad setChild: nil];
    [newQuad setParent: nil];
    [baby setQuad: newQuad];

    return baby;
}

-addSpeciesParams
{
    [super addSpeciesParams];

    [species addParam: "SmellRadius" Vary: 0 DValue: smell_radius
          Message: M(setSmellRadius:) Owner: self];
    [species addParam: "EatsColor" Vary: 0 IValue: colorsToEat[0]
          Message: M(eatColor:) Owner: self];

    return self;   
}

-eatColor: (int) c
{
    int i;

    if (numColors == MAXCHOOSYCOLORS) {
        geckoError(InvalidCombination,
            "Too many colors for CCG_Kris\n");
        return self;
    }
    for (i=0; i < numColors; i++) {
        if (colorsToEat[i] == c)
            return self;
    }
    colorsToEat[numColors] = c;
    numColors++;
    
    // due to parameter loading order in protocol--otherwise, overwrites 
    // prior parameter, so two copies of current value....
    if (numColors > 1) {
        [species addParam: "EatsColor" Vary: 0 IValue: colorsToEat[numColors-2]
            Message: M(eatColor:) Owner: self];
    }
    return self;
}

-(int) getNumColors { return numColors;}
-(int) getColor: (int) i { return colorsToEat[i]; }
-setSmellRadius: (GRate) sr { smell_radius = sr; return self; }
-(GRate) getSmellRadius { return smell_radius; }

-(BOOL) attacks: (Animal*) other
    // if proper color, I attack.
{
    int i;
    for (i=0; i < numColors; i++) {
        if ([other getGColor] == colorsToEat[i]) {
            return 1;
        }
    }
    return 0;
}	

-(BOOL) withinVeerX: (GCoord) px Y: (GCoord) py VeersBy: (double*) dangle
{
    double angle, preyangle, d;

    angle = [self getDirectionAngle];
    preyangle = angleToward(x, y, px, py);
    d = preyangle - angle;

    // max angle -between- is M_PI, so fold in...    
    if (d > M_PI) {
        d = preyangle - (angle + 2.0 * M_PI);
    } else if (d < -M_PI) {
        d = (preyangle + 2.0 * M_PI) - angle;
    }
    
    *dangle = d;
        
    if (fabs(d) < (veer/2.0))
        return 1;
    else
        return 0;
}

-newDirection
    // NOTE:  This code is known not to work correctly.  Compare with 
    // newDirection in ColorChoosyGrazer.  I elected NOT to backfit my 
    // corrections there, because CCG_Kris exists for backward compatibility.
    // vfb, 970307.
    
    // Argh.  There's no nice way to do this, obeying veer.  So:
    // 	1. Project a circle between current center and edge of smell_r,
    //     along current angle (direction) from center.
    //  2. Use that as a pick window.
    //  3. If multiple choices, the target is the one closest to angle.
    //  4. For direction, use half the angle off current direction to center
    //     of target organism, unless violates veer, in which case, use veer.
    //  5. If can't find anything, use random veer.
    // This is NOT equivalent to searching over smell-radius circle within
    // veer.  But I don't have the tools to do that.
{
    Quad * pq;
    Animal* plant, *anyplant;
    double dangle, veerangle, angle;
	double mindangle = 0;
    GCoord projectx, projecty, projectr;
    Quad* plantRoot = [[geckoControl getModelSwarm] getPlantRoot];

    // project hunt circle from our center, to smell-radius, along angle.    
    angle = [self getDirectionAngle];
    projectr = smell_radius * radius / 2.0;
    projectx = x + projectr * (cos(angle));
    projecty = y + projectr * (sin(angle));
    [feedwin circleToSquare: projectx Y: projecty Radius: projectr];
    pq = [plantRoot pickWin: feedwin Root: plantRoot Invisibles: 0];

    anyplant  = nil;	// any plant I can eat

    do {
        plant = pq->data;
        if ([self attacks: plant]) {
            if (!anyplant) {
                anyplant = plant;
                if ( [self withinVeerX: plant->x Y: plant->y VeersBy: &dangle] )
                    mindangle = dangle;
                else {
                    if (dangle < 0)
                        mindangle = - veer/2.0;
                    else
                        mindangle = veer/2.0;
                }
            } else { // compare to previous plant
                if ( [self withinVeerX: plant->x Y: plant->y VeersBy: &dangle] ) 
					mindangle = dangle;
                if (fabs(dangle) < fabs(mindangle)) {
                    anyplant = plant;
                    mindangle = dangle;
                } 
			}
        }
        pq = [pq pickWin: feedwin Root: plantRoot Invisibles: 0];
    } while ((pq));
    
    if (anyplant) {
        angle = angle + mindangle;
        [self setDirectionX: cos(angle) Y: sin(angle)];
    } else {
        dangle = [self getDirectionAngle];
        veerangle = (veer/2.0) * [randSource evenRand];
        if ([randSource evenRand] < 0.5) 
            veerangle = - veerangle;
        dangle += veerangle;
        [self setDirectionX: cos(dangle) Y: sin(dangle)];
    }

    return self;
}


-hunt
    // How much I want to eat depends on -my- size & tax debt & growthrate.
    // Hunt for any plant that satisfies that desire, settle for smaller
    // one if can't have what we want.
{
    Animal* plant;
    ResType  me   = [energy getIam];
    ResType  meat = [energy getIeat];
    ResQuant mybite;
    GCoord   mybiter;
    ResQuant myvol;
    
    myvol   = [energy getStores: me];
    mybite  = ([energy getTaxRate: me] * pow(myvol, [energy getTaxExponent: me]))
              + growrate * myvol;
    mybite /= [energy getConvertFrom: [energy getIeat] To: me];
    mybiter = volume2radius(mybite, 1.0, scalev);

    plant = [self bestpreyMin: mybiter];
    
    if ((plant)) {
        if ([plant getRadius] > mybiter) {
            [plant stealRes: meat Amount: mybite];
        } else {
            mybite = [plant stealAllRes: meat];
        }
        [plant resetRadius];  // since another may choose to eat him.
        [self feedRes: meat Amount: mybite];
    }

    [self newDirection];
      
    if ((plant)) {  
        lastmealx = plant->x;
        lastmealy = plant->y;
    } else {
        [self setDirectionX: lastmealx - x Y: lastmealy - y];
    }
    
    return self;    
}

-printv
{
    int i;
    [super printv];
    printLogD("growrate = %7f, ", growrate);
    printLogD("smell_radius = %7lf, ", smell_radius);
    printLog("adultTime = %3d, ", adultTime);
    printLog("moverule = %d, ", moverule);
    printLog("eatsColor = %d", colorsToEat[0]);
    if (numColors > 1) 
        for (i=1; i<numColors; i++)
            printLog(", %d", colorsToEat[i]);
            
    printLog("\n\n");
    return self;
}
@end




@implementation TimeLimitGrazer

TimeLimitGrazer* recycleTimeLimitGrazers = 0;
Mcr* huntwin;
Mcr* feedwin;

-recycle
{
    [species tallyDeath: self];
    
    hook = recycleTimeLimitGrazers;
    recycleTimeLimitGrazers = self;
    [species decrementCensus];
    return nil;
}

-recycleClear
{
    TimeLimitGrazer* togo;
    while (recycleTimeLimitGrazers) {
        togo = recycleTimeLimitGrazers;
        recycleTimeLimitGrazers = recycleTimeLimitGrazers->hook;
        [togo->energy drop];
        [togo drop];
    }
    return self;
}


-reuse
{
    TimeLimitGrazer* result = recycleTimeLimitGrazers;
    recycleTimeLimitGrazers = recycleTimeLimitGrazers->hook;
    result->hook   = nil;
    return result;
}

+create 
{
    id result;
    
    if (recycleTimeLimitGrazers) {
        result = [recycleTimeLimitGrazers reuse];
    } else {
        result = [TimeLimitGrazer createBegin: globalZone];
        [result allocEnergy];
    }
    [result init];
    
    return result;					
}

-copymom
    // create an agent matching mom in all heritable respects
{
    TimeLimitGrazer* baby;
    Quad* newQuad;

    baby = [TimeLimitGrazer create];
    baby->species   = species;
    [energy copyTo: baby->energy];
    baby->color     = color;
    [species incrementCensus];
    [species tallyBirth: self];
    baby->breedsize = 10000;
    baby->kidsize   = kidsize;
    baby->minsize   = minsize;
    baby->scaleradius = scaleradius;
    baby->scalev = scalev;
    baby->growrate  = growrate;
    baby->lastmealx = lastmealx;
    baby->lastmealy = lastmealy;
    baby->veer      = veer;
    baby->moverule  = moverule;
    baby->adultTime = adultTime;
    baby->maxAge    = maxAge;

    newQuad = [Quad create];
    [newQuad setData: baby Type: critter];
    [newQuad setSibling: nil];
    [newQuad setChild: nil];
    [newQuad setParent: nil];
    [baby setQuad: newQuad];

    return baby;
}
-setAdultTime: (int) at { adultTime = at; return self;}
-(int) getAdultTime { return adultTime;}
-setMaxAge: (int) ma { maxAge = ma; return self;}
-(int) getMaxAge { return maxAge;}

-addSpeciesParams
{
    [super addSpeciesParams];

    [species addParam: "AdultTime" Vary: 0 IValue: adultTime
          Message: M(setAdultTime:) Owner: self];
    [species addParam: "MaxAge" Vary: 0 IValue: maxAge
          Message: M(setMaxAge:) Owner: self];

    return self;   
}

-liveGrandma: (Species*) s
{
    [huntwin drop];
    huntwin = [Mcr create];
    [feedwin drop];
    feedwin = [Mcr create];

    [energy addConvertFrom: carbos To: proteins Rate: (1.0/3.0)];
    [energy addTax: proteins Rate: .365 Exponent: .75]; // .08
    breedsize   = 10000;
    kidsize     = 3.2;
    minsize     = 3.0;
    scaleradius = 1.0;
    scalev = 1.0/M_PI;
    growrate    = .0306;
    veer        = 3.77; // M_PI;
    adultTime   = 133;
    maxAge      = 0;
    
    species = s;
    [self setGColor: [species getGColor]];
    [self addSpeciesParams];
    
    return self;
}

-(BOOL) reproduce
    // False if didn't.  For now, select random angle for kid.
    // Also set breeding radius for first time.
{
    TimeLimitGrazer* baby;
    GCoord distance;
    ResList* kidgets;
    ResQuant minbreed;
    double angle;
    Quad* myRoot;
    
    if ([geckoControl getCurrentTime] == (adultTime + birthday)) {
        kidgets = [self kidshare];
        minbreed = volume2radius(kidgets->list[[energy getIam]] * 2.0, 
            scaleradius, scalev);
        if (minbreed > radius) {
            breedsize = minbreed;
        } else {
            breedsize = radius;
        }
    } else if ([geckoControl getCurrentTime] < (adultTime + birthday)) {
        return 0;
    }
    
    if (radius < breedsize)
        return 0;

    angle = 2.0 * M_PI * [randSource evenRand];

    // record a birth
    if (kidcount == 0)
        firstbornon = [geckoControl getCurrentTime];
    kidcount++;

    // make the kid
    baby         = [self copymom];
    distance     = [self getChildRadius];
    baby->x      = x + ( distance * cos(angle) );
    baby->y      = y + ( distance * sin(angle) );
    baby->wannax = cos(angle);
    baby->wannay = sin(angle);
    baby->radius = kidsize;

    // transfer resources 
    kidgets = [self kidshare];
    [energy debit: kidgets];
    [self resetRadius];
    baby->energy = [baby->energy setStores:  kidgets];

    // hang on quad tree
    [baby getMcr: baby->myquad->mcr];
    myRoot = myquad->parent;
    while ((myRoot->type != sessile) && (myRoot->type != mobile))
        myRoot = myRoot->parent;
    [myRoot addNode: baby->myquad];

    [kidgets drop];
    return 1;
}

-maxAgeCheck
{
    if (maxAge > 0) {
        if ((birthday + maxAge) <= [geckoControl getCurrentTime]) {
            [self die];
            return 0;
        }
    }
    return self;
}

-step 
    // One step in the lifecycle of a TimeLimitGrazer.
    // Note: returns nil if dies--higher level routine deletes, because
    // higher level routine is traversing the tree.
{
    [self metabolize];
 
    if (![self paytax]) 
        return nil;
    if (![self maxAgeCheck])
        return nil;
    if (![self reproduce]) {
        [self hunt];
    }
    [self move];

    return self;
}

-printv
{
    [super printv];
    printLogD("growrate = %7f, ", growrate);
    printLogD("veer = %7lf, ", veer);
    printLog("adultTime = %3d, ",adultTime);
    printLog("maxAge = %3d\n",maxAge);
    printLog("moverule = %d\n\n", moverule);
    return self;
}
@end

@implementation ColorChoosyGrazer

ColorChoosyGrazer* recycleColorChoosyGrazers = 0;
Mcr* huntwin;
Mcr* feedwin;

-recycle
{
    [species tallyDeath: self];
    
    hook = recycleColorChoosyGrazers;
    recycleColorChoosyGrazers = self;
    [species decrementCensus];
    return nil;
}

-recycleClear
{
    ColorChoosyGrazer* togo;
    while (recycleColorChoosyGrazers) {
        togo = recycleColorChoosyGrazers;
        recycleColorChoosyGrazers = recycleColorChoosyGrazers->hook;
        [togo->energy drop];
        [togo drop];
    }
    return self;
}


-reuse
{
    ColorChoosyGrazer* result = recycleColorChoosyGrazers;
    recycleColorChoosyGrazers = recycleColorChoosyGrazers->hook;
    result->hook   = nil;
    return result;
}

-init
{
    int i;
    [super init];
    colorsToEat = (int*) [globalZone alloc: MAXCHOOSYCOLORS * sizeof(int)];
    for (i=0; i< MAXCHOOSYCOLORS; i++)
        colorsToEat[i] = -1;
    numColors = 0;
    return self;
}

+create 
{
    id result;
    
    if (recycleColorChoosyGrazers) {
        result = [recycleColorChoosyGrazers reuse];
    } else {
        result = [ColorChoosyGrazer createBegin: globalZone];
        [result allocEnergy];
    }
    [result init];
    
    return result;					
}

-copymom
    // create an agent matching mom in all heritable respects
{
    ColorChoosyGrazer* baby;
    Quad* newQuad;
    int i;

    baby = [ColorChoosyGrazer create];
    baby->species   = species;
    [energy copyTo: baby->energy];
    baby->color     = color;
    [species incrementCensus];
    [species tallyBirth: self];
    baby->breedsize = 10000;
    baby->kidsize   = kidsize;
    baby->minsize   = minsize;
    baby->scaleradius = scaleradius;
    baby->scalev = scalev;
    baby->growrate  = growrate;
    baby->lastmealx = lastmealx;
    baby->lastmealy = lastmealy;
    baby->veer      = veer;
    baby->moverule  = moverule;
    baby->adultTime = adultTime;
    baby->maxAge    = maxAge;

    baby->smell_radius = smell_radius;
    baby->numColors = numColors;
    for (i=0; i<numColors; i++)
        baby->colorsToEat[i] = colorsToEat[i];

    newQuad = [Quad create];
    [newQuad setData: baby Type: critter];
    [newQuad setSibling: nil];
    [newQuad setChild: nil];
    [newQuad setParent: nil];
    [baby setQuad: newQuad];

    return baby;
}

-addSpeciesParams
{
    [super addSpeciesParams];

    [species addParam: "SmellRadius" Vary: 0 DValue: smell_radius
          Message: M(setSmellRadius:) Owner: self];
    [species addParam: "EatsColor" Vary: 0 IValue: colorsToEat[0]
          Message: M(eatColor:) Owner: self];

    return self;   
}

-eatColor: (int) c
{
    int i;

    if (numColors == MAXCHOOSYCOLORS) {
        geckoError(InvalidCombination,
            "Too many colors for ColorChoosyGrazer\n");
        return self;
    }
    for (i=0; i < numColors; i++) {
        if (colorsToEat[i] == c)
            return self;
    }
    colorsToEat[numColors] = c;
    numColors++;
    
    // due to parameter loading order in protocol--otherwise, overwrites 
    // prior parameter, so two copies of current value....
    if (numColors > 1) {
        [species addParam: "EatsColor" Vary: 0 IValue: colorsToEat[numColors-2]
            Message: M(eatColor:) Owner: self];
    }
    return self;
}

-(int) getNumColors { return numColors;}
-(int) getColor: (int) i { return colorsToEat[i]; }
-setSmellRadius: (GRate) sr { smell_radius = sr; return self; }
-(GRate) getSmellRadius { return smell_radius; }

-(BOOL) attacks: (Animal*) other
    // if proper color, I attack.
{
    int i;
    for (i=0; i < numColors; i++) {
        if ([other getGColor] == colorsToEat[i]) {
            return 1;
        }
    }
    return 0;
}	

-(BOOL) withinVeerX: (GCoord) px Y: (GCoord) py VeersBy: (double*) dangle
{
    double angle, preyangle, d;

    angle = [self getDirectionAngle];
    preyangle = angleToward(x, y, px, py);
    d = preyangle - angle;

    // max angle -between- is M_PI, so fold in...    
    if (d > M_PI) {
        d = preyangle - (angle + 2.0 * M_PI);
    } else if (d < -M_PI) {
        d = (preyangle + 2.0 * M_PI) - angle;
    }
    
    *dangle = d;
        
    if (fabs(d) < (veer/2.0))
        return 1;
    else
        return 0;
}

-newDirection
    // Argh.  There's no nice way to do this, obeying veer.  So:
    // 	1. Project a circle between current center and edge of smell_r,
    //     along current angle (direction) from center.
    //  2. Use that as a pick window.
    //  3. If multiple choices, the target is the one closest to angle.
    //  4. For direction, use half the angle off current direction to center
    //     of target organism, unless violates veer, in which case, use veer.
    //  5. If can't find anything, use random veer.
    // This is NOT equivalent to searching over smell-radius circle within
    // veer.  But I don't have the tools to do that.
{
    Quad * pq;
    Animal* plant, *anyplant;
    double dangle, veerangle, angle;
	double mindangle = 0;
    GCoord projectx, projecty, projectr;
    Quad* plantRoot = [[geckoControl getModelSwarm] getPlantRoot];

    // first, randomly reset direction based on veer
    angle = [self getDirectionAngle];
    veerangle = (veer/2.0) * [randSource evenRand];
    if ([randSource evenRand] < 0.5) 
        veerangle = - veerangle;
    angle += veerangle;
    [self setDirectionX: cos(angle) Y: sin(angle)];

    // project hunt circle from our center, to smell-radius, along angle.    
    angle = [self getDirectionAngle];
    projectr = smell_radius * radius / 2.0;
    projectx = x + projectr * (cos(angle));
    projecty = y + projectr * (sin(angle));
    [feedwin circleToSquare: projectx Y: projecty Radius: projectr];
    pq = [plantRoot pickWin: feedwin Root: plantRoot Invisibles: 0];

    anyplant  = nil;	// any plant I can eat

    do {
        plant = pq->data;
        if ([self attacks: plant]) {
            if (!anyplant) {
                anyplant = plant;
                if ( [self withinVeerX: plant->x Y: plant->y VeersBy: &dangle] )
                    mindangle = dangle;
                else {
                    if (dangle < 0)
                        mindangle = - veer/2.0;
                    else
                        mindangle = veer/2.0;
                }
            } else { // compare to previous plant
                if ( [self withinVeerX: plant->x Y: plant->y VeersBy: &dangle] ) ;
                if (fabs(dangle) < fabs(mindangle)) {
                    anyplant = plant;
                    mindangle = dangle;
                }
            }	
        }
        pq = [pq pickWin: feedwin Root: plantRoot Invisibles: 0];
    } while ((pq));
    
    if (anyplant) {
        angle = angle + mindangle;
        [self setDirectionX: cos(angle) Y: sin(angle)];
    } else {
        [self setDirectionX: lastmealx - x Y: lastmealy - y];
    }

    return self;
}


-hunt
    // How much I want to eat depends on -my- size & tax debt & growthrate.
    // Hunt for any plant that satisfies that desire, settle for smaller
    // one if can't have what we want.
{
    Animal* plant;
    ResType  me   = [energy getIam];
    ResType  meat = [energy getIeat];
    ResQuant mybite;
    GCoord   mybiter;
    ResQuant myvol;
    
    myvol   = [energy getStores: me];
    mybite  = ([energy getTaxRate: me] * pow(myvol, [energy getTaxExponent: me]))
              + growrate * myvol;
    mybite /= [energy getConvertFrom: [energy getIeat] To: me];
    mybiter = volume2radius(mybite, 1.0, scalev);

    plant = [self bestpreyMin: mybiter];
    
    if ((plant)) {
        if ([plant getRadius] > mybiter) {
            [plant stealRes: meat Amount: mybite];
        } else {
            mybite = [plant stealAllRes: meat];
        }
        [plant resetRadius];  // since another may choose to eat him.
        [self feedRes: meat Amount: mybite];
    }

    if ((plant)) {  
        lastmealx = plant->x;
        lastmealy = plant->y;
    }

    if (smell_radius > 0.0) {
        [self newDirection];
    } else if (!(plant)) {  
        [self setDirectionX: lastmealx - x Y: lastmealy - y];
    }
    
    return self;    
}

-printv
{
    int i;
    [super printv];
    printLogD("growrate = %7f, ", growrate);
    printLogD("smell_radius = %7lf, ", smell_radius);
    printLog("adultTime = %3d, ", adultTime);
    printLog("moverule = %d, ", moverule);
    printLog("eatsColor = %d", colorsToEat[0]);
    if (numColors > 1) 
        for (i=1; i<numColors; i++)
            printLog(", %d", colorsToEat[i]);
            
    printLog("\n\n");
    return self;
}
@end

@implementation ScaredyGrazer

ScaredyGrazer* recycleScaredyGrazers = 0;
Mcr* huntwin;
Mcr* feedwin;
#define MAXLONG          (0x7FFFFFFF)
#define SCAREDYFAR MAXLONG*1000.0 // no maxdouble on win32

-recycle
{
    [species tallyDeath: self];
    
    hook = recycleScaredyGrazers;
    recycleScaredyGrazers = self;
    [species decrementCensus];
    return nil;
}

-recycleClear
{
    ScaredyGrazer* togo;
    while (recycleScaredyGrazers) {
        togo = recycleScaredyGrazers;
        recycleScaredyGrazers = recycleScaredyGrazers->hook;
        [togo->energy drop];
        [togo drop];
    }
    return self;
}


-reuse
{
    ScaredyGrazer* result = recycleScaredyGrazers;
    recycleScaredyGrazers = recycleScaredyGrazers->hook;
    result->hook   = nil;
    return result;
}

-init
{
    [super init];
    
    refuge = nil;
    scaredof = nil;
    smell_radius = 1.0;
    refuge_radius = 1.0;
    refugeGrowrate = growrate;
    lastPredatorDistance = 0.0;
    mood = ScaredyHappy;

    return self;
}

+create 
{
    id result;
    
    if (recycleScaredyGrazers) {
        result = [recycleScaredyGrazers reuse];
    } else {
        result = [ScaredyGrazer createBegin: globalZone];
        [result allocEnergy];
    }
    [result init];
    
    return result;					
}

-copymom
    // create an agent matching mom in all heritable respects
{
    ScaredyGrazer* baby;
    Quad* newQuad;

    baby = [ScaredyGrazer create];
    baby->species   = species;
    [energy copyTo: baby->energy];
    baby->color     = color;
    [species incrementCensus];
    [species tallyBirth: self];
    baby->breedsize = 10000;
    baby->kidsize   = kidsize;
    baby->minsize   = minsize;
    baby->scaleradius = scaleradius;
    baby->scalev = scalev;
    baby->growrate  = growrate;
    baby->lastmealx = lastmealx;
    baby->lastmealy = lastmealy;
    baby->veer      = veer;
    baby->moverule  = moverule;
    baby->adultTime = adultTime;
    baby->maxAge    = maxAge;
    
    baby->smell_radius = smell_radius;
    baby->refuge_radius = refuge_radius;
    baby->refugeGrowrate = refugeGrowrate;
    baby->refuge = refuge;
    baby->scaredof = scaredof;
    
    baby->lastPredatorDistance = 0.0;

    newQuad = [Quad create];
    [newQuad setData: baby Type: critter];
    [newQuad setSibling: nil];
    [newQuad setChild: nil];
    [newQuad setParent: nil];
    [baby setQuad: newQuad];

    return baby;
}

-(BOOL) reproduce
    // False if didn't.  For now, select random angle for kid.
    // Also set breeding radius for first time.
{
    ScaredyGrazer* baby;
    GCoord distance;
    ResList* kidgets;
    ResQuant minbreed;
    double angle;
    Quad* myRoot;
    GeckoModelSwarm* model = [geckoControl getModelSwarm];
    
    if ([geckoControl getCurrentTime] == (adultTime + birthday)) {
        kidgets = [self kidshare];
        minbreed = volume2radius(kidgets->list[[energy getIam]] * 2.0, 
            scaleradius, scalev);
        if (minbreed > radius) {
            breedsize = minbreed;
        } else {
            breedsize = radius;
        }
    } else if ([geckoControl getCurrentTime] < (adultTime + birthday)) {
        return 0;
    }
    
    if (radius < breedsize)
        return 0;

    angle = 2.0 * M_PI * [randSource evenRand];

    // record a birth
    if (kidcount == 0)
        firstbornon = [geckoControl getCurrentTime];
    kidcount++;

    // make the kid
    baby         = [self copymom];
    distance     = [self getChildRadius];
    baby->x      = x + ( distance * cos(angle) );
    baby->y      = y + ( distance * sin(angle) );
    baby->wannax = cos(angle);
    baby->wannay = sin(angle);
    baby->radius = kidsize;
    
    if (model->settings->season > 0)
        baby->mood   = ScaredyEgg;

    // transfer resources 
    kidgets = [self kidshare];
    [energy debit: kidgets];
    [self resetRadius];
    baby->energy = [baby->energy setStores:  kidgets];

    // hang on quad tree
    [baby getMcr: baby->myquad->mcr];
    myRoot = myquad->parent;
    while ((myRoot->type != sessile) && (myRoot->type != mobile))
        myRoot = myRoot->parent;
    [myRoot addNode: baby->myquad];

    [kidgets drop];
    return 1;
}

-addSpeciesParams
{
    [super addSpeciesParams];

    [species addParam: "SmellRadius" Vary: 0 DValue: smell_radius 
          Message: M(setSmellRadius:) Owner: self];
    [species addParam: "RefugeRadius" Vary: 0 DValue: refuge_radius 
          Message: M(setRefugeRadius:) Owner: self];
    [species addParam: "RefugeGrowRate" Vary: 0 DValue: refugeGrowrate
          Message: M(setRefugeGrowRate:) Owner: self];
    [species addParam: "Refuge" Vary: 0 SValue: [refuge getParamName]
          Message: M(setRefugeByName:) Owner: self];
    [species addParam: "ScaredOf" Vary: 0 SValue: [scaredof getParamName]
          Message: M(setScaredOfByName:) Owner: self];

    return self;   
}

-setSmellRadius: (GRate) sr {smell_radius = sr; return self;}
-(GRate) getSmellRadius {return smell_radius;}
-setRefugeRadius: (GRate) rr {refuge_radius = rr; return self;}
-(GRate) getRefugeRadius {return refuge_radius;}
-setRefuge: (Species*) safety {refuge = safety; return self;}
-(Species*) getRefuge { return refuge; }
-setRefugeGrowRate: (GRate) rgr {refugeGrowrate = rgr; return self;}
-(GRate) getRefugeGrowRate {return refugeGrowrate;}
-(char*) getRefugeByName {return [refuge getParamName];}
-setScaredOf: (Species*) s {scaredof = s; return self;}
-(Species*) getScaredOf { return scaredof; }
-(char*) getScaredOfByName {return [scaredof getParamName];}

-setRefugeByName: (char*) safety
{
    Parameterized* def = [species getParameterized: safety];
    if (!def) {
        geckoError(InvalidCombination,
            "Cannot find ScaredyGrazer refuge species '%s'.\n",
            safety);  
    } else {
        refuge = (Species*) def;
    }
    return self;
}

-setScaredOfByName: (char*) s
{
    Parameterized* def = [species getParameterized: s];
    if ((!def) && (strcmp(s, ""))) {
        geckoError(InvalidCombination,
            "Cannot find ScaredyGrazer scared-of species '%s'.\n", s);  
    } else {
        scaredof = (Species*) def;
    }
    return self;
}

-printv
{
    [super printv];
    printLogD("smell_radius = %7f, ", smell_radius);
    printLogD("refuge_radius = %7lf, ", refuge_radius);
    printLogD("refugeGrowrate = %7lf, ", refugeGrowrate);
    printLog("refuge = %s\n", [refuge getParamName]);
    return self;
}

-(BOOL) hiddenExposed: (Mcr*) exposed
    // am I entirely hidden by refuge plants?
{
    Quad * pq;
    Animal* plant;
    McrRelation hidingpower;
    Quad* plantRoot = [[geckoControl getModelSwarm] getPlantRoot];

    if (mood == ScaredyEgg) 
        return 1;
    
    if (!feedwin) feedwin = [Mcr create];
    [feedwin circleToSquare: x Y: y Radius: radius];

    pq = [plantRoot pickWin: feedwin Root: plantRoot Invisibles: 0];
    if (pq) do {
        plant = pq->data;
        if (plant->species == refuge) {
            if (!feedwin) feedwin = [Mcr create];
            [feedwin circleToSquare: x Y: y Radius: radius];
            hidingpower = [feedwin unIntersectMcr: pq->mcr
                           unIntersection: feedwin];
            // easiest case, I'm entirely contained within this plant
            if (hidingpower == containedby) {
                return 1;
            }
            // all other cases, either the plant didn't help me or the
            // feedwin's been reset to reflect the partial cover
        }
        pq = [pq pickWin: feedwin Root: plantRoot Invisibles: 0];
    } while ((pq));
    
    exposed = feedwin;
    return 0;
}

-(BOOL) threatAtX: (GCoord*) tx Y: (GCoord*) ty Distance: (GCoord*) d
     // is a predator within smell_radius? returns distance
{
    Quad* tq;
    Animal* thing;
    GCoord dist, closest;
    Quad* mobileRoot = [[geckoControl getModelSwarm] getMobileRoot];
    
    closest = SCAREDYFAR;

    tq = [mobileRoot pickRadius: (radius * smell_radius)
         X: x Y: y Root: mobileRoot];
    if (tq) do {
        thing = tq->data;
        if ([thing getSpecies] == scaredof) {
            dist = distance(x, y, [thing getX], [thing getY]);
            dist = dist - [thing getRadius] - [self getRadius];
            if (dist < closest) {
                closest = dist;
                *tx = [thing getX];
                *ty = [thing getY];
                *d = dist;
            }
        }
        tq = [tq pickRadius: (radius * smell_radius) X: x Y: y Root: mobileRoot];
    } while ((tq));
    
    if (closest < SCAREDYFAR) { 
        return 1;
    } else {
        return 0;
    }
}

-(BOOL) refugeAtX: (GCoord*) rx Y: (GCoord*) ry Distance: (GCoord*) d
    // should generalize, but don't feel like it this moment....
{
    Quad* tq;
    Animal* thing;
    GCoord dist, closest;
    int toosmall, thissmall;// 1 if closest to date was too small to hide me
    Quad* plantRoot = [[geckoControl getModelSwarm] getPlantRoot];
    
    closest = SCAREDYFAR;
    toosmall = 1;
    
    tq = [plantRoot pickRadius: (radius * refuge_radius)
         X: x Y: y Root: plantRoot];
    if (tq) do {
        thing = tq->data;
        if ([thing getSpecies] == refuge) {
            dist = distance(x, y, [thing getX], [thing getY]);
            dist = dist - [thing getRadius] - [self getRadius];
            thissmall = ([thing getRadius] < [self getRadius]);

            // three cases:  
            // 1. no refuge found yet, any is better than none.
            // 2. big refuge found at dist, only closer is better
            // 3. too-small refuge found at dist, any bigger is better

            if ( (closest == SCAREDYFAR) ||                             // 1.
                 ( (!toosmall) && (!thissmall) && (dist < closest) ) || // 2.
                 ( (toosmall) && (!thissmall) )                         // 3.
               ) {
                toosmall = thissmall;
                closest = dist;
                *rx = [thing getX];
                *ry = [thing getY];
                *d  = dist;
            }
        }
        tq = [tq pickRadius: (radius * refuge_radius)
            X: x Y: y Root: plantRoot];
    } while ((tq));
    
    if (closest < SCAREDYFAR) { 
        return 1;
    } else {
        return 0;
    }
}

-move
{
    GCoord scratchx, scratchy;

    if (wannadistance <= 0.0)
        return self;
    if (wannadistance > [self getRadius])
        wannadistance = [self getRadius];
    [self getDirectionX: &scratchx Y: &scratchy]; // ignore, because reset wanna's
    x += fabs(wannadistance) * wannax;
    y += fabs(wannadistance) * wannay;
    [self getMcr: myquad->mcr];
    [myquad growMcr];
    return self;
}

-(Animal*) bestpreyWithin: (GCoord) range Size: (GCoord) normalBiteR 
    RefugeSize: (GCoord) refugeBiteR
    // Choose a plant--kinda arbitrary logic, so localize.
    // Don't care how big plant is, so long as it's bigger than minradius
    // but will return plant smaller than minradius, if can't find bigger.
{
    Quad * pq;
    Animal* plant, *bestplant, *anyother, *bestother, *anyrefuge, *bestrefuge;
    Quad* plantRoot = [[geckoControl getModelSwarm] getPlantRoot];

    pq = [plantRoot pickRadius: range X: x Y: y Root: plantRoot];

    bestrefuge = nil;	
    bestother  = nil;
    anyrefuge  = nil;	// some refuge (better than none)
    anyother   = nil;	// some plant (better than none)
    
    if (pq) do {
        plant = pq->data;
        if ([self attacks: plant]) {
            if ([plant getSpecies] == refuge) {
                if ([plant getRadius] > refugeBiteR) {
                    if ((bestrefuge) && ([randSource evenRand] > 0.5))
                        bestrefuge = plant;
                    else if (!bestrefuge)
                        bestrefuge = plant;
                } else
                    if ((anyrefuge) && ([randSource evenRand] > 0.5))
                        anyrefuge = plant;
                    else if (!anyrefuge)
                        anyrefuge = plant;
            } else {
                if ([plant getRadius] > normalBiteR) {
                    if ((bestother) && ([randSource evenRand] > 0.5))
                        bestother = plant;
                    else if (!bestother)
                        bestother = plant;
                } else
                    if ((anyother) && ([randSource evenRand] > 0.5))
                        anyother = plant;
                    else if (!anyother)
                        anyother = plant;
            }
        }
        pq = [pq pickRadius: range X: x Y: y Root: plantRoot];
    } while ((pq));

    if (mood != ScaredyHappy) {
        if (bestrefuge)
            bestplant = bestrefuge;
        else if (anyrefuge)
            bestplant = anyrefuge;
        else if (bestother)
            bestplant = bestother;
        else bestplant = anyother;
    } else {
        if (bestother)
            bestplant = bestother;
        else if (bestrefuge)
            bestplant = bestrefuge;
        else if (anyother)
            bestplant = anyother;
        else bestplant = anyrefuge;
    }
    
    return bestplant;
}

-calcBite: (GCoord*) normalR Refuge: (GCoord*) refugeR
    // find what radius of plant will satisfy my growth and tax desires.
{
    ResType me = [energy getIam];
    ResQuant mybite, refugebite;
    GCoord   mybiter, refugebiter;
    GRate converts;
    ResQuant myvol;

    myvol   = [energy getStores: me];
    mybite  = ([energy getTaxRate: me] * pow(myvol, [energy getTaxExponent: me]));
    refugebite = mybite;
    mybite += growrate * myvol;
    refugebite += refugeGrowrate * myvol;
    converts = [energy getConvertFrom: [energy getIeat] To: me];
    mybite /= converts;
    refugebite /= converts;
    
    mybiter = volume2radius(mybite, 1.0, scalev);
    refugebiter = volume2radius(refugebite, 1.0, scalev);

    *normalR = mybiter;
    *refugeR = refugebiter;
    return self;
}

-eatIt: (Animal*) lunch BiteR: (GCoord) r1
        RefugeBiteR: (GCoord) r2
{
    GCoord r;
    ResQuant vol;
    ResType meat = [energy getIeat];
    
    if (!lunch)
        return self;
    
    if (lunch->species == refuge) 
        r = r2;
    else 
        r = r1;
    
    vol = radius2volume(r, 1.0, scalev);
    
    if ([lunch getRadius] > r) {
        [lunch stealRes: meat Amount: vol];
    } else {
        vol = [lunch stealAllRes: meat];
    }
    [lunch resetRadius];  // since another may choose to eat him.
    [self feedRes: meat Amount: vol];
    
    return self;
}
    

-hunt
    // How much I want to eat depends on -my- size & tax debt & growthrate.
    // Hunt for any plant that satisfies that desire, settle for smaller
    // one if can't have what we want.
    
    // For ScaredyGrazer, much complicated by evasive action.
{
    Animal* plant;
    GCoord normalBiteR, refugeBiteR;
    double angle, veerangle;
    GCoord threatx, threaty, threatd;
    GCoord safex, safey, safed;
    BOOL   safe, threatened;

    wannadistance = [self getRadius]; // until proven otherwise

    if (!huntwin) huntwin = [Mcr create];
    safe = [self hiddenExposed: huntwin]; 
    threatened = [self threatAtX: &threatx Y: &threaty Distance: &threatd];
    
    // 1. what's happening? always need current distance to threat, if any
    if ((!safe) && (threatened)) {
        if (mood == ScaredyHappy) {
            mood = ScaredyFroze;
            lastPredatorDistance = threatd;
            wannadistance = 0.0;
            return self;
        } else if (mood == ScaredyFroze) {
            mood = ScaredyRun;
            if (threatd < lastPredatorDistance) {
                lastPredatorDistance = threatd;
                if ([self refugeAtX: &safex Y: &safey Distance: &safed]) {
                    [self setDirectionX: safex - x Y: safey - y];
                    wannadistance = safed + 2.0 * [self getRadius];
                } else {
                    [self setDirectionX: x - threatx Y: y - threaty];
                }
                return self;
            } else {
                [self setDirectionX: x - threatx Y: y - threaty];
            }
        } else { // mood == ScaredyRun
            lastPredatorDistance = threatd;
            if ([self refugeAtX: &safex Y: &safey Distance: &safed]) {
                [self setDirectionX: safex - x Y: safey - y];
                wannadistance = safed + 2.0 * [self getRadius];
            } else {
                [self setDirectionX: x - threatx Y: y - threaty];
            }
        }

    } else if (safe && threatened) {
        mood = ScaredyRun;
        lastPredatorDistance = threatd;
        if ([self refugeAtX: &safex Y: &safey Distance: &safed]) {
            [self setDirectionX: safex - x Y: safey - y];
            wannadistance = safed + 2.0 * [self getRadius];
        } else {
            [self setDirectionX: x - threatx Y: y - threaty];
        }
    } else { 
        mood = ScaredyHappy;
        lastPredatorDistance = SCAREDYFAR;
        
        // get set to mill around (unless find no food)
        angle = [self getDirectionAngle];
        veerangle = (veer/2.0) * [randSource evenRand];
        if ([randSource evenRand] < 0.5) 
            veerangle = - veerangle;
        angle += veerangle;
        [self setDirectionX: cos(angle) Y: sin(angle)];
    }

    // 2. figure out how much to eat if we get the chance
    
    [self calcBite: &normalBiteR Refuge: &refugeBiteR]; 
    plant = [self bestpreyWithin: [self getRadius] 
            Size: normalBiteR RefugeSize: refugeBiteR];
    
    if ((plant)) {
        [self eatIt: plant BiteR: normalBiteR RefugeBiteR: refugeBiteR];
    } else {
        // look farther--if can smell spiders over this area, can certainly
        // find food that far, so lastmealx, lastmealy irrelevant 
        // use smell instead of refuge, because want closer answer.
        plant = [self bestpreyWithin: ([self getRadius] * smell_radius)
                 Size: normalBiteR RefugeSize: refugeBiteR];
        if ((plant)) {
            angle = angleToward(x, y, [plant getX], [plant getY]);
            [self setDirectionX: cos(angle) Y: sin(angle)];
        } else {
            // last idea was as good as any....
        }
    }
    
    return self;    
}

-countAndDie
    // optional season--reset, add to initNum, and die
{
    static int today;
    int myAge;
    
    // once per season, per run
    if (today != [geckoControl getCurrentTime]) {
        today = [geckoControl getCurrentTime];
        [species setInitNum: 0];
    }
    myAge = [geckoControl getCurrentTime] - birthday;
    if (myAge < maxAge) {
        [species setInitNum: [species getInitNum] + 1];
    }
    [self die];
    return 0;
}

-step
{
    // eggs do nothing, not even metabolism
    if (mood == ScaredyEgg) 
        return self;
    [super step];
    return self;
}


@end
