// vfb, orig, 951020:

#import "QuadDisplay.h"
#import "Critter.h"
#import "GrazerZoo.h"
#import "Carnie.h"
#import "ResourceQuad.h"
#import "Diffuse.h"
#import "Mcr.h"
#import "GeckoControlSwarm.h"

@implementation QuadDisplay

// 23040 = 360 * 64 ... feel free to complain to whoever wrote XDrawArc
#define CircleAngle 23040

// Note:  I only set quad colors in the draw routines, and I deeply distrust
// having draw routines edit the data they're drawing.  Hence, this variable.
int quadColor; 		

-(int) w2pX: (double) wx
{
    return( (int) ((wx - wminx) * ppw) );
}

-(int) w2pY: (double) wy
{
    return( (int) ((wmaxy - wy) * ppw) );
}

-setQuadToDisplay: (Quad *) q 
{
  quadroot = q;
  displayquads = 0;
  return self;
}

-setcolormap
{
    id <Colormap> mymap;	
    int i;
    
    mymap = [Colormap create: globalZone];
    
    // Color 0 is black.
    [mymap setColor: 0 ToRed: 0 Green: 0 Blue: 0];
    
    // At the moment, critters are green.
    for (i=FirstCritterColor; i <= LastCritterColor; i++) {
        [mymap setColor: i ToRed: 0 Green: 1.0 
                           Blue: (double) i / 6.0];
    }

    // At the moment, goppers are yellow.
    [mymap setColor: GrazerColor ToRed: 1.0 Green: 1.0 Blue: 0];
    [mymap setColor: GrazerBabyColor ToRed: 1.0 Green: 0.5 Blue: 0];
    [mymap setColor: GrazerColorRed ToRed: 1.0 Green: 0.0 Blue: 0];
    [mymap setColor: GrazerColorOrange ToRed: 1.0 Green: 0.75 Blue: 0];

    // At the moment, spiders are purple.
    [mymap setColor: CarnieColor ToRed: 1.0 Green: 0.25 Blue: 1.0];
    [mymap setColor: CarnieSmellColor ToRed: .75 Green: 0.0 Blue: .85];
    [mymap setColor: CarnieDormantColor ToRed: .75 Green: 0.0 Blue: .75];

    // Quad colors are progressively dimmer grays.
    for (i = 0; i <= (LastQuadColor - FirstQuadColor); i++)
        [mymap setColor: FirstQuadColor+i
              ToRed: (0.75 - (double)i / 16.0)
              Green: (0.75 - (double)i / 16.0)
              Blue:  (0.75 - (double)i / 16.0)];
    
    // Ground colors are progressively richer browns.
    for (i = GroundPoorColor; i <= GroundRichColor; i++)
        [mymap setColor: i
              ToRed: ( 0.25 + ((i - GroundPoorColor) / 16.0) )
              Green: 0.1
              Blue:  0.1];
            
    // diffusion rainbow...hack for now
    // JanK's more-blue==higher concentration scheme
    for (i = HighDiffuseColor; i <= LowDiffuseColor; i++) {
        [mymap setColor: i   
            ToRed: (0.0 + ( (i - HighDiffuseColor) / 30.0) )
            Green: (0.0 + ( (i - HighDiffuseColor) / 30.0) )
            Blue: 1.0]; 
    }
    /* mine
    i = HighDiffuseColor;
    [mymap setColor: i   ToRed: 1.0 Green: 1.0  Blue: 1.0];  // white
    [mymap setColor: i+1 ToRed: 1.0 Green: .875 Blue: .875]; // dimming pink
    [mymap setColor: i+2 ToRed: 1.0 Green: .750 Blue: .750];
    [mymap setColor: i+3 ToRed: 1.0 Green: .625 Blue: .625];
    [mymap setColor: i+4 ToRed: 1.0 Green: .500 Blue: .500];
    [mymap setColor: i+5 ToRed: 1.0 Green: .375 Blue: .375];
    [mymap setColor: i+6 ToRed: 1.0 Green: 0    Blue: 0   ]; // red
    [mymap setColor: i+7 ToRed: 1.0 Green: .500 Blue: 0];    // orange
    [mymap setColor: i+8 ToRed: 1.0 Green: .625 Blue: 0];
    [mymap setColor: i+9 ToRed: 1.0 Green: .750 Blue: 0];
    [mymap setColor: i+10 ToRed: 1.0 Green: .938 Blue: 0];
    [mymap setColor: i+11 ToRed: 1.0 Green: 1.0  Blue: 0];   // yellow
    [mymap setColor: i+12 ToRed: .625 Green: 1.0 Blue: 0];
    [mymap setColor: i+13 ToRed: 0 Green: .938 Blue: 0];     // green
    [mymap setColor: i+14 ToRed: 0 Green: .750 Blue: 0];
    [mymap setColor: i+15 ToRed: 0 Green: .625 Blue: 0];
    [mymap setColor: i+16 ToRed: 0 Green: .500 Blue: 0];
    [mymap setColor: i+17 ToRed: .250 Green: .5 Blue: 1.0];
    [mymap setColor: i+18 ToRed: 0 Green: 0 Blue: 1.0];	     // blue
    [mymap setColor: i+19 ToRed: 0 Green: 0 Blue: .875];
    [mymap setColor: i+20 ToRed: .5 Green: 0 Blue: .875];
    [mymap setColor: i+21 ToRed: .625 Green: .5 Blue: .875];
    [mymap setColor: i+22 ToRed: .625 Green: 0 Blue: .875];
    [mymap setColor: i+23 ToRed: .875 Green: 0 Blue: .875];
    [mymap setColor: i+24 ToRed: .875 Green: .5 Blue: .938];
    [mymap setColor: i+25 ToRed: .5 Green: .5 Blue: 1.0];
    [mymap setColor: i+26 ToRed: .5 Green: .5 Blue: .75];
    [mymap setColor: i+27 ToRed: .625 Green: 0  Blue: .625];
    [mymap setColor: i+28 ToRed: .5 Green: 0  Blue: .5];
    [mymap setColor: i+29 ToRed: 0 Green: 0  Blue: .5];
    */
     
    [super setColormap: mymap];
    return(self);
}

-setDisplayQuadFlag: (BOOL) flag
{
    displayquads = flag;
    return(self);
}

-(void) drawNode: (Quad*) q
{
    // this should clip.  Skip for now.
    // also want drawn xor-on, undrawn with xor-off.  Figure out later.

    int radius;
    int i, j, imax, jmax;
    int px, py, lenx, leny;
    Critter * c;
    DiffuseQuad * dq;
    //GRate d;

    if (!(q->visible)) return;
    
    if (isagent(q->type)) {
        c = q->data;
        
/* look at mcr's 
        XSetForeground(Tk_Display(tkwin), gc, map[69]);  
        px = [self w2pX: q->mcr->lx];
        py = [self w2pY: q->mcr->uy];
        lenx = [self w2pX: q->mcr->ux];
        lenx = lenx - px;
        leny = [self w2pY: q->mcr->ly];
        leny = leny - py;
        XDrawRectangle(Tk_Display(tkwin), pm, gc, px, py, lenx, leny);
*/
        
        radius = (int) (c->radius * ppw);
        px = [self w2pX: c->x];
        py = [self w2pY: c->y];
        

		[self ellipseX0: px - radius Y0: py - radius
		             X1: px + radius Y1: py + radius
					 Width: CIRCLE_THICKNESS
					 Color: [q->data getGColor]];
        
/* look at equiv. squares instead of circles
        [square circleToSquare: c->x Y: c->y Radius: c->radius];
        px = [self w2pX: square->lx];
        py = [self w2pY: square->uy];
        lenx = (int) (ppw * (square->ux - square->lx));
        leny = (int) (ppw * (square->uy - square->ly));
        XDrawRectangle(Tk_Display(tkwin), pm, gc, px, py, lenx, leny);
*/
                
    } else if (q->type == diffuse) {
        dq = (DiffuseQuad*) q;
        px = [self w2pX: wminx];
        py = [self w2pY: wmaxy];
        lenx = (int) (ppw * (wmaxx - wminx));
        leny = (int) (ppw * (wmaxy - wminy));
	// draw the background
	[self fillRectangleX0: px  Y0: px
	      X1: px+lenx Y1: py+leny
	      Color: [dq getColorDensity: 0]];

        // draw the foreground
        imax = [dq getCellsX];
        jmax = [dq getCellsY];
        for (i=0; i < imax; i++) {
            for (j=0; j < jmax; j++) {
                // XSetForeground(Tk_Display(tkwin), gc, 
                //    map[[dq getColorCellX: i Y: j]]);
                px = [self w2pX: [dq getMcrLXCellX: i Y: j]];
                py = [self w2pY: [dq getMcrUYCellX: i Y: j]];
                lenx = (int) (1 + ppw * 
                        ( [dq getMcrUXCellX: i Y: j] - 
                            [dq getMcrLXCellX: i Y: j] ) );
                leny = (int) (1 + ppw * 
                        ( [dq getMcrUYCellX: i Y: j] - 
                            [dq getMcrLYCellX: i Y: j] ) );
				[self fillRectangleX0: px      Y0: py
				                   X1: px+lenx Y1: py+leny
							   Color: [dq getColorCellX: i Y: j]];

            }
        }
    } else if (q->type == feed) {
        px = [self w2pX: q->mcr->lx];
        py = [self w2pY: q->mcr->uy];
        lenx = (int) (ppw * (q->mcr->ux - q->mcr->lx));
        leny = (int) (ppw * (q->mcr->uy - q->mcr->ly));
		[self fillRectangleX0: px      Y0: px 
				           X1: px+lenx Y1: py+leny 
						   Color: q->color];
    } else if (displayquads) {
        px = [self w2pX: q->mcr->lx];
        py = [self w2pY: q->mcr->uy];
        lenx = (int) (ppw * (q->mcr->ux - q->mcr->lx));
        leny = (int) (ppw * (q->mcr->uy - q->mcr->ly));
		[self rectangleX0: px      Y0: px 
			           X1: px+lenx Y1: py+leny 
					   Width: 1
					   Color: quadColor];
    }
}

-(void) drawTree: (int) color Root: (Quad *) root
    // Just traverse the tree and display it.  The color
    // parameter actually sets the starting color--it's incremented as
    // we descend the tree.
    // These trees can be vast--don't do both directions recursively....
{
    Quad* thislevel = root;
    int savecolor = quadColor;
    
    if (root == nil) 
        return;
    
    quadColor = color;
    if (quadColor > LastQuadColor) 
        quadColor = LastQuadColor;
    
    do {
        [self drawTree: color+1 Root: thislevel->child];
        [self drawNode: thislevel]; 
    } while ((thislevel = thislevel->sibling) != nil);  

    quadColor = savecolor;
}

-drawTree
     // Update translations and kick off the recursion. 
     // Note, I got sick of the window zooming out as goppers got stupid,
     // so hardcoded to look at landRoot instead of quadroot (mine).
{
    // find limiting aspect--in which dimension does tree fit tightest?
    // allow additional 20 pixels on each side in that dimension.
    int margin = 40;
    LandRoot* landRoot = [[geckoControl getModelSwarm] getLandRoot];

    GCoord xsize = landRoot->mcr->ux - landRoot->mcr->lx;
    GCoord ysize = landRoot->mcr->uy - landRoot->mcr->ly;
/*
    // want to watch spiders wander off to their deaths?
    GCoord xsize = worldRoot->mcr->ux - worldRoot->mcr->lx;
    GCoord ysize = worldRoot->mcr->uy - worldRoot->mcr->ly;
*/

    // here, fac = world per pix
    double facx = xsize / (double)(width - margin);
    double facy = ysize / (double)(height - margin);
    double fac = facx > facy ? facx : facy;

    // center world on window
    wminx = 0.5 * ( (landRoot->mcr->lx + landRoot->mcr->ux) - (fac * width) );
    wmaxx = wminx + (fac * width);
    wminy = 0.5 * ( (landRoot->mcr->ly + landRoot->mcr->uy) - (fac * height) );
    wmaxy = wminy + (fac * height);
    
    // here, fac = pix per world
    facx = (double)(width) / (wmaxx - wminx);
    facy = (double)(height) / (wmaxy - wminy);
    ppw = facx < facy ? facx : facy;
    
    // printLog("Time: %d\n", [geckoControl getCurrentTime]);
    [self drawTree: FirstQuadColor Root: quadroot];    
    return self;
}

@end
