// The definition of a Land(scape) object. vfb rewrite, 951221.
// Overhaul for adding DiffuseQuad, vfb, 970424 begin.
		
#import "Base.h"
#import "Mcr.h"
#import "Quad.h"
#import "Res.h"
#import "Colors.h"
#import "Animal.h"
#import "Stat.h"
#import "Site.h"

// Warning:  at some point, FeedQuad should be upgraded to have a Metabolism,
// so that it can recycle resources, instead of modeling with individual
// agents, which is computationally cumbersome.  For instance, taxes (including
// dead critters) could be recycled at some efficiency back into plantfood.

// Also warning:  ResourceQuad's think they ought to feed all sessile
// agents under plantRoot.  If you wish your agents to take responsibility,
// call them Mobile, whether they're particularly mobile or not.


// ResourceQuad is a dummy class--use subclass Uniform or Diffuse

@interface ResourceQuad: Quad {
  @public
    Site*	siteDef;	// site definition
    ResType     resource;	// each only contains one resource....
    ResQuant	startres;	// reservoir at stepResource end
    ResQuant	reservoir;	// reservoir now
    ResQuant	fed;		// amount fed out
}
+create;

-landGrandma: (Site*) s;			// subclassed

-(ResQuant) feedCritter: (Animal*) eater 
       Amount: (ResQuant) amount Area: (Mcr*) m;  // subclassed
       
-stepResources;					  // subclassed

-(BOOL) produces: (ResType) res;  // one feedquad, any type
-(ResQuant) fedOut;	 	
-(ResQuant) fedOutP;	 	
-zeroFed;
	 	
-(GRate) getDensityAtX: (GCoord) x Y: (GCoord) y; // point density
-addResourceAmount: (ResQuant) amount X: (GCoord) x Y: (GCoord) y;
-(ResQuant) getReservoir;

-setMcrLX: (GCoord) x1;
-setMcrLY: (GCoord) y1;
-setMcrUX: (GCoord) x2;
-setMcrUY: (GCoord) y2;
-setResource: (ResType) res;
-(char*) getName;
-setMcrLX: (GCoord) x1 LY: (GCoord) y1 UX: (GCoord) x2 UY: (GCoord) y2;

-print;
-println;
-printv;

@end
