// Original, vfb, 970424.

#import "Base.h"
#import "ResourceQuad.h"
#import "LandRoot.h"
#import "random.h"
#import "Animal.h"
#import "GeckoControlSwarm.h"
#import <simtools.h>
#import <math.h>

@implementation ResourceQuad

-init 
{
    siteDef  	 = nil;
    mcr          = [[Mcr create] setNullMcr];
    type     	 = feed;	
    parent   	 = nil;
    sibling  	 = nil;
    child    	 = nil;
    visible    	 = 1;
    resource     = nullres;
    startres     = 0;
    reservoir    = 0;
    return self;
}

+create 
{
    id result = [[ResourceQuad createBegin: globalZone] createEnd];
    [result init];
    return result;					
}

// subclassed
-landGrandma: (Site*) s {return 0;}
-(ResQuant) getReservoir { return reservoir; }

-(ResQuant) feedCritter: (Animal*) eater 
       Amount: (ResQuant) amount Area: (Mcr*) m {return 0;}
       
-stepResources {return self;}

-(BOOL) produces: (ResType) res {return (resource == res);}

-setMcrLX: (GCoord) x1 LY: (GCoord) y1 UX: (GCoord) x2 UY: (GCoord) y2
{
    mcr->lx = x1;
    mcr->ux = x2;
    mcr->ly = y1;
    mcr->uy = y2;
    [self growMcr];
    
    return self;
}
-setMcrLX: (GCoord) x1 {mcr->lx = x1;[self growMcr];return self;}
-setMcrLY: (GCoord) y1 {mcr->ly = y1;[self growMcr];return self;}
-setMcrUX: (GCoord) x2 {mcr->ux = x2;[self growMcr];return self;}
-setMcrUY: (GCoord) y2 {mcr->uy = y2;[self growMcr];return self;}
-setResource: (ResType) res {resource = res; return self;}
-(char*) getName { return [siteDef getParamName];}
-(ResQuant) fedOut {return (fed);}	 	
-(ResQuant) fedOutP {return ((fed) / startres);}	 	
-zeroFed {fed = 0; return self;}	 	

-(GRate) getDensityAtX: (GCoord) x Y: (GCoord) y; 
    // point density
{
    if ([mcr ptInsideX: x Y: y])
        return (reservoir / [mcr areaMcr]);
    return 0; 
}

-addResourceAmount: (ResQuant) amount X: (GCoord) x Y: (GCoord) y
    // AMOUNT, not density
{
    if ([mcr ptInsideX: x Y: y])
        reservoir += amount;
    return self;
}

-print
{
    printLog("produces %d over ", resource);
    [mcr print];
    return self;
}

-println
{
    [self print];
    printLog("\n");
    return self;
}

-printv
{
    printLog(object_get_class_name(self)); [self println];
    printLogD("    startres = %lf ", startres);
    printLogD(" reservoir = %lf\n", reservoir);
    return self;
}

@end

