// 960102, prototype, vfb.
// 970909, rework, vfb.

#import <objc/objc-api.h>
#import <objectbase.h>
#import <objectbase/SwarmObject.h>
#import "Quad.h"	
#import "OtherDisplay.h"	

// i/o manager -- not sure how to do this nicely, but need it NOW.
// Very aggravating--can't figure out how to get sprintf/fprintf to accept
// doubles like printf can with this argument passing mechanism.  Have to
// print doubles specially....

// For now, don't rework these as Obj-C calls. 
extern void printLogD(char* fmt, double D);
extern void printBacD(char* fmt, double D);
extern void printPorD(char* fmt, double D);
extern void printDiffD(char* fmt, double D);
extern void printArchiveD(char* fmt, double D);
extern void printBothD(char* fmt, double D);
extern void printAllD(char* fmt, double D);
extern void printLog();
extern void printBac();
extern void printPor();
extern void printDiff();
extern void printArchive();
extern void printBoth();
extern void printAll();
extern void flushAll();

// generic counters for bucket (distribution) stat
@interface GenericBucket: SwarmObject {
  @public
    int* counters;		// int tallies
    int numCounters;
    double* summers;		// arbitrary quantity sums
    int numSummers;
    double* derived;		// whatever stats derived in this bucket
    int numDerived;
}
+createCounters: (int) nc Sums: (int) ns Derived: (int) nd;
-clear;
-calc;				// noop--can be no default derived calculation
-addData: (GenericBucket*) substat; // add substat data (not derived) to this

-(int) getTotal;		// of counters
-(double) getDoubleTotal;	// of summers
-(int) getNumCounters;		
-(int) getNumSummers;		
-(int) getNumDerived;		
-(int) getCount: (int) i;		
-(double) getDerived: (int) i;		
-(double) getSum: (int) i;		
-setCount: (int) i Value: (int) num;		
-incCount: (int) i; 		// add one		
-setSum: (int) i Value: (double) quant;		
-incSum: (int) i Value: (double) quant;		
-setDerived: (int) i Value: (double) d;		
-println;
@end

// generic counters for bucket (distribution) stat
@interface BucketDistrib: SwarmObject {
  @public
    id* bucket;			// array of each-bucket whatever-stat objects
    id  totalBucket;		// data (not derived) summed in this bucket
    int maxBucket;		
    int total;			// always need a total of something....
    double dtotal;		// always need a total of something....
}
-init: (int) buckets Type: (char*) classname
    Counters: (int) nc Sums: (int) ns Derived: (int) nd;

+createMax: (int) buckets Type: (char*) classname
    Counters: (int) nc Sums: (int) ns Derived: (int) nd;

-(int) getMaxBucket;		

-(int) getTotal;
-(double) getDoubleTotal;
-calc;				      // default doesn't do much....
-addBucket: (BucketDistrib*) substat; // add substat data (not derived) to this

-clear;				// zero out all buckets
-tallyBucket: (int) b Which: (int) which; // add one to a counter
-tallyBucket: (int) b Which: (int) which Quant: (double) quant; // add quant to a summer
-(double) getBucket: (int) b Derived: (int) which;
-(double) getBucket: (int) b Sum: (int) which;
-(int) getBucket: (int) b Counter: (int) which;
-printv;			
@end

#define AGE_COUNTERS 4
#define AGE_DERIVED 3
#define AGE_COUNT_MEMBERS 0
#define AGE_COUNT_KIDS 1
#define AGE_COUNT_BIRTHS 2
#define AGE_COUNT_DEATHS 3
#define AGE_DERIVE_MX 0
#define AGE_DERIVE_PX 1
#define AGE_DERIVE_AGEPERCENT 2
@interface AgeCounters: GenericBucket {
/* counters:
    0 members;		// at end of age--tallied by doStats
    1 kids;			// tallied at each birth
    2 births;			// tallied at each birth
    3 deaths;			// tallied at each death
derived:
    0 mx;			// maternity average #offspring at this age
    1 px;			// percent mortality this age
    2 agepercent;		// percent of all ages are this age
*/ 
}
+create;
@end;

// assorted counters for age structure
// pay attention to what is specified in rounds, statcycles, or superages
@interface AgeStructure: BucketDistrib {
}
+createAges: (int) buckets;
-(int) getMaxAge;		// return ages, not rounds
-calc;
-tallyBirthToMom: (id) mom;
-tallyDeath: (id) goner;
-tallyAlive: (id) one;
-printv;
@end

// SizeStructure is identical to AgeStructure, simply calls getSizeBucket 
// instead of getAgeBucket to decide where to tally.
@interface SizeStructure: AgeStructure {
}
+createSizes: (int) buckets;
-tallyBirthToMom: (id) mom;
-tallyDeath: (id) goner;
-tallyAlive: (id) one;
-printv;
@end

// StageStructure is identical to AgeStructure, simply calls getStageBucket 
// instead of getAgeBucket to decide where to tally.
@interface StageStructure: AgeStructure {
}
+createStages: (int) buckets;
-tallyBirthToMom: (id) mom;
-tallyDeath: (id) goner;
-tallyAlive: (id) one;
-printv;
@end

#define SPECIFIC_EVENT_BORN 0
#define SPECIFIC_EVENT_HADKID 1
#define SPECIFIC_EVENT_DIED 2
#define SPECIFIC_EVENT_ISALIVE 3
#define SPECIFIC_EVENT_GREW 4
#define SPECIFIC_EVENT_THEFT 5
#define SPECIFIC_EVENT_STARVED 6
// any event thats none-of-the-above should be given as
// SPECIFIC_EVENT_BASE + offset (0..whatever)
#define SPECIFIC_EVENT_BASE 7

// SpecificStructure is intended for subclassing.
@interface SpecificStructure: BucketDistrib {
}

// Counters are
// for integer tallies, sums are for double sums, derived is the number of
// statistics derived from the observations in counters and sums, and each
// bucket already has an int and a double total field.
+createBuckets: (int) buckets Counters: (int) nc 
          Sums: (int) ns Derived: (int) nd;

-tallyBirthToMom: (id) mom;
-tallyDeath: (id) goner;
-tallyAlive: (id) one;
-tallyGrowth: (id) c Amount: (ResQuant) b;
-tallyLossSteal: (id) c Amount: (ResQuant) b;
-tallyLossStarve: (id) c Amount: (ResQuant) b;
-tallySpecific: (id) aCritter EventType: (int) anEvent;
@end

@interface BiomassRates: SwarmObject {
  @public
    // counted, then divided by statcyle
    ResQuant     growth;	// biomass increase (after taxes, before losses)
    ResQuant     lossSteal;	// biomass stealRes losses during statcycle
    ResQuant     lossStarve;	// biomass starvation deaths during statcycle
    // derived
    ResQuant     netGrowth;	// net biomass increase of members (after losses)
    ResQuant     losses;	// lossSteal + lossStarve
    ResQuant     lastNetGrowth;	// last netGrowth value
    ResQuant     netRatio;	// net/lastnet (lastnet = 1 if 0--should be rare)
}
+create;

-clear;
-calcNet: (ResQuant) b;
-tallyGrowth: (id) c Amount: (ResQuant) b;
-tallyLossSteal: (id) c Amount: (ResQuant) b;
-tallyLossStarve: (id) c Amount: (ResQuant) b;
-printv;
@end

// BiomassTransfers is same as Rates, sans the dividing out into rates
@interface BiomassTransfers: BiomassRates {
  @public
    ResQuant     biomass;	
}
+create;
-clear;
-calcNet: (ResQuant) b;
-printv;
@end


