// vfb, 9601??--have been fiddling with all along.
// vfb, orig, 951020:  mockup for testing Quad & Mcr code.

#import "Base.h"
#import "RandSource.h"
#import "GeckoControlSwarm.h"
#import <simtools.h>
#import <activity.h>

GeckoControlSwarm * geckoControl;
RandSource * randSource;

int main(int argc, const char ** argv) 
{
    int arg;
    int starttime;
    int startrun;

    // Swarm initialization: all Swarm apps must call this first.
	// 980402, vfb:  however, if you have any arguments other than the ones
	// swarm thinks should be there, it takes the liberty of crashing and
	// telling you what your arguments *ought* to be.....

    initSwarm(1, argv);

    geckoControl = [GeckoControlSwarm create: globalZone];
    randSource   = [RandSource create];

    // the argc (argument counter) includes the program name (gecko), hence we start at arg=1 and stop at argc-1
    for (arg=1; arg < argc; arg++) {
      if (! strcmp(argv[arg], "-batch")) {
	[geckoControl setDisplayFlag: 0];
      } else if (! strcmp(argv[arg], "-proto")) {
	[geckoControl setProtocol: argv[arg+1]];
	arg++; // skip the next arg
      } else if (! strcmp(argv[arg], "-restart")) {
	// need two more arguments for -restart, and may have more other arguments
	if (argc-1 >= arg+2) { // argc-1 is the number of tokens after the program name
	  if ( atoi(argv[arg+1]) >= 0 ) {
	    starttime = atoi(argv[arg+1]);
	    [geckoControl setRestartFlag];
	    [geckoControl setStartTime: starttime];
	  } else {
	  geckoError(SourceMessage, \
	    "\n\nERROR: Wrong time argument to -restart option!\n\n\nUsage: -restart starttime>= 0 startrun>= 1\n\n\n");
	  }
	  if ( atoi(argv[arg+2]) >= 1 ) {
	    startrun = atoi(argv[arg+2]);
	    [geckoControl setStartRun: startrun];
	  } else {
	  geckoError(SourceMessage, \
	    "\n\nERROR: Wrong run argument to -restart option!\n\n\nUsage: -restart starttime>=0 startrun>=1\n\n\n");
	  }
	  arg += 2; // skip the next two args
	} else {
	  geckoError(SourceMessage, \
	    "\n\nERROR: Missing arguments to -restart option!\n\n\nUsage: -restart starttime startrun\n\n\n");
	}
      } else { // none of the possible options found, if we have only one arg, it could be --help, -h, ?
	if (argc == 2) {
	  geckoError(SourceMessage, \
	    "\n\nERROR: Wrong arguments!\n\n\nUsage: gecko [-batch] [-proto foo] [-restart starttime startrun]\n\n\n");
	}
      }
    }
    
    [geckoControl buildObjects];
    
    // main loop
    do {
        [geckoControl buildActions];
        [geckoControl activateIn: nil];
        [geckoControl go];
    } while ([geckoControl getGeckoRuns] > 0);
    
    return 0;					  // all done! Exit.
}
